unit untLstEditor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, ComCtrls, ToolWin, ImgList, SynEdit, SynMemo, StdCtrls;

type
  TfrmEditLst = class(TForm)
    grdLst: TStringGrid;
    tlbrLstEditor: TToolBar;
    tlbtnLstExit: TToolButton;
    tlbtnOpenLst: TToolButton;
    tlbtnSaveLst: TToolButton;
    tlbtnLstSeparator1: TToolButton;
    imglstBtnLst: TImageList;
    opndlgOpenLst: TOpenDialog;
    stsbrLstEditor: TStatusBar;
    rcdtTempLst: TSynMemo;
    tlbtnRegScript: TToolButton;
    tlbtnLstSep1: TToolButton;
    tlbtnAddStr: TToolButton;
    tlbtnDelStr: TToolButton;
    tlbtnLstSep2: TToolButton;
    tlbtnGoBegin: TToolButton;
    tlbtnFindDown: TToolButton;
    tlbtnFindUp: TToolButton;
    edtFindInLst: TEdit;
    tlbtnGoEnd: TToolButton;
    tlbtnLstSep3: TToolButton;
    tlbtnLstSep4: TToolButton;
    procedure FormShow(Sender: TObject);
    procedure tlbtnLstExitClick(Sender: TObject);
    procedure tlbtnOpenLstClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure tlbtnSaveLstClick(Sender: TObject);
    procedure grdLstKeyPress(Sender: TObject; var Key: Char);
    procedure tlbtnRegScriptClick(Sender: TObject);
    procedure tlbtnDelStrClick(Sender: TObject);
    procedure grdLstGetEditText(Sender: TObject; ACol, ARow: Integer;
      var Value: String);
    procedure grdLstSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure tlbtnAddStrClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure grdLstKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure grdLstDblClick(Sender: TObject);
    procedure grdLstMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure tlbtnGoBeginClick(Sender: TObject);
    procedure tlbtnFindDownClick(Sender: TObject);
    procedure tlbtnFindUpClick(Sender: TObject);
    procedure tlbtnGoEndClick(Sender: TObject);
    procedure edtFindInLstKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure edtFindInLstChange(Sender: TObject);
  private
    { Private declarations }
    procedure GridDlgMSGInitial;
    procedure LoadLst(const AName: String);
    procedure LoadLst1(const AName: String);
    function SavedLst(const AName: string): Boolean;
    function CheckClearString(ANum: Word):Boolean;
    function ChangeInLst(Sender: TObject): Boolean;
    function FindInLst(const AStr: string; ToDown: Boolean): Boolean;
    
  public
    { Public declarations }
    procedure LoadLstShadow(const AName: String);
  end;

procedure ShowLstEditor;

const
  CR = #13#10;
  CNewLst = '  (lst-)  ';
  //CNameFormLst = '  - [';

var
  frmEditLst: TfrmEditLst;
  FlagEditLst: Boolean; //    
  LstName: string; //   lst-
  AStrEsc: string; //      ESC
  xc, yc: Integer; //    
  CtrlPress: Boolean;

implementation

uses WorkINI, MathPNO, untMain;

{$R *.DFM}

procedure ShowLstEditor;
begin
  with TfrmEditLst.Create(Application) do
    try
      FlagEditLst := True;
      ShowModal;
    finally
      Free;
      FlagEditLst := False;
    end;
end;

procedure TfrmEditLst.FormShow(Sender: TObject);
begin
  stsbrLstEditor.Panels[0].Text := CNewLst;
  GridDlgMSGInitial;
  //frmLstEditor.Caption := CNameFormLst + CNewLst + ']';
end;

procedure TfrmEditLst.GridDlgMSGInitial;
begin //   
  grdLst.EditorMode := False;
  grdLst.SetFocus;
  grdLst.Cols[0].Clear;
  grdLst.Cols[1].Clear;
  grdLst.Cols[2].Clear;
  grdLst.Cols[3].Clear;
  grdLst.RowCount := 2;
  grdLst.Cells[0,1] := '1';
  grdLst.Cells[0,0] := '.';
  grdLst.Cells[1,0] := '';
  grdLst.Cells[2,0] := '  ';
  grdLst.Cells[3,0] := 'LVARs';
  grdLst.Options := grdLst.Options - [goEditing];
  edtFindInLst.SetFocus;
end;

procedure TfrmEditLst.tlbtnLstExitClick(Sender: TObject);
begin //  lst-     
  grdLst.EditorMode := False;
  ModalResult := mrCancel;
end;

procedure TfrmEditLst.LoadLst1(const AName: String);
var
  AStr: string;
  nl, APos: Integer;
begin //  lst-   
  //frmEditLst.Enabled := False; //     
  //grdLst.Visible := False; //     
  //rcdtTempLst.Lines.LoadFromFile(AName);
  for nl:=0 to rcdtTempLst.Lines.Count-1 do
  begin
    Application.ProcessMessages();
    if rcdtTempLst.Lines[nl]='' then Continue; //    
    //AStr := StrDosToWinSpec(rcdtTempMSG.Lines[nl], a);
    AStr := rcdtTempLst.Lines[nl];
    with grdLst do
    begin
      APos := PosTf(';', AStr, 0); //      
      Cells[0,RowCount-1] := IntToStr(nl+1);
      Cells[1,RowCount-1] := Trim(Copy(AStr, 0, APos-1));
      Cells[2,RowCount-1] := Trim(Copy(AStr, APos+1, PosTf('#', AStr, APos+1)-APos-1));
      APos := Pos('local_vars=', AStr)+11; //     local_vars
      Cells[3,RowCount-1] := Trim(Copy(AStr, APos, Length(AStr)-APos+1));
      RowCount := RowCount + 1;
    end;
  end;
  //rcdtTempLst.Lines.Clear;
  //grdLst.Visible := True;
  //frmEditLst.Enabled := True;
  //grdLst.SetFocus;
  //stsbrLstEditor.Panels[0].Text := AName;
end;

procedure TfrmEditLst.LoadLst(const AName: String);
var
  AStr, ANInt: string;
  i, nl: Integer;
begin //  lst-
  frmEditLst.Enabled := False; //     
  grdLst.Visible := False; //     
  rcdtTempLst.Lines.LoadFromFile(AName);
  tlbtnSaveLst.Enabled := False;
  for nl:=0 to rcdtTempLst.Lines.Count-1 do
  begin
    Application.ProcessMessages();
    if rcdtTempLst.Lines[nl]='' then Continue; //    
    AStr := rcdtTempLst.Lines[nl];
    if (Copy(AStr, 17 ,1)<>';') or (Copy(AStr, 65 ,1)<>'#') or
       (Copy(AStr, 77 ,1)<>'=') then
    begin
      grdLst.Visible := True;
      frmEditLst.Enabled := True;
      GridDlgMSGInitial;
      if MessageBox(GetForegroundWindow, //     GetForegroundWindow
                 PChar(' "'+AName+'"'+//CR+
                       '     '+CR+
                       '     ' + IntToStr(nl+1)+'.'+CR+CR+
                       '-   ? '),
                 PChar('  '), MB_ICONERROR + MB_YESNO)=IDYES then
      begin
        //Exit;
        //ShowMessage('Stop');
        frmEditLst.Enabled := False; //     
        grdLst.Visible := False; //     
        LoadLst1(AName); //   
        tlbtnSaveLst.Enabled := True;
        Break;
      end
      else Exit;
    end;
    with grdLst do
    begin
      Cells[0,RowCount-1] := IntToStr(nl+1);
      Cells[1,RowCount-1] := Trim(Copy(AStr, 0, 16));
      Cells[2,RowCount-1] := Trim(Copy(AStr, 18, 47));
      Cells[3,RowCount-1] := Trim(Copy(AStr, 78, Length(AStr)-77));
      RowCount := RowCount + 1;
    end;
  end;
  with grdLst do
  begin
    Cells[0, RowCount-1] := IntToStr(RowCount-1);
    rcdtTempLst.Lines.Clear;
    Visible := True;
    frmEditLst.Enabled := True;
    //tlbtnSaveLst.Enabled := False;
    SetFocus;
    stsbrLstEditor.Panels[0].Text := AName;
    Options := Options + [goEditing];
    ANInt := ChangeFileExt(ExtractFileName(AFileName), '.int');
    for i:=1 to RowCount-1 do
      if AnsiLowerCase(ANInt)=AnsiLowerCase(Cells[1, i]) then
      begin //      ,   
        Row := i;
        Col := 1;
        edtFindInLst.SetFocus;
        Exit;
      end;
    Row := RowCount - 1; //    
  end;
  edtFindInLst.SetFocus;
end;

procedure TfrmEditLst.LoadLstShadow(const AName: String);
var
  AStr, ANInt: string;
  i, nl: Integer;
begin //  lst-
  frmEditLst.Enabled := False; //     
  grdLst.Visible := False; //     
  rcdtTempLst.Lines.LoadFromFile(AName);
  tlbtnSaveLst.Enabled := False;
  for nl:=0 to rcdtTempLst.Lines.Count-1 do
  begin
    Application.ProcessMessages();
    if rcdtTempLst.Lines[nl]='' then Continue; //    
    AStr := rcdtTempLst.Lines[nl];
    if (Copy(AStr, 17 ,1)<>';') or (Copy(AStr, 65 ,1)<>'#') or
       (Copy(AStr, 77 ,1)<>'=') then
    begin
      grdLst.Visible := True;
      frmEditLst.Enabled := True;
      GridDlgMSGInitial;
      if MessageBox(GetForegroundWindow, //     GetForegroundWindow
                 PChar(' "'+AName+'"'+//CR+
                       '     '+CR+
                       '     ' + IntToStr(nl+1)+'.'+CR+CR+
                       '-   ? '),
                 PChar('  '), MB_ICONERROR + MB_YESNO)=IDYES then
      begin
        //Exit;
        //ShowMessage('Stop');
        frmEditLst.Enabled := False; //     
        grdLst.Visible := False; //     
        LoadLst1(AName); //   
        tlbtnSaveLst.Enabled := True;
        Break;
      end
      else Exit;
    end;
    with grdLst do
    begin
      Cells[0,RowCount-1] := IntToStr(nl+1);
      Cells[1,RowCount-1] := Trim(Copy(AStr, 0, 16));
      Cells[2,RowCount-1] := Trim(Copy(AStr, 18, 47));
      Cells[3,RowCount-1] := Trim(Copy(AStr, 78, Length(AStr)-77));
      RowCount := RowCount + 1;
    end;
  end;
  with grdLst do
  begin
    Cells[0, RowCount-1] := IntToStr(RowCount-1);
    rcdtTempLst.Lines.Clear;
    Visible := True;
    frmEditLst.Enabled := True;
    //tlbtnSaveLst.Enabled := False;
    //SetFocus;
    stsbrLstEditor.Panels[0].Text := AName;
    Options := Options + [goEditing];
    ANInt := ChangeFileExt(ExtractFileName(AFileName), '.int');
    for i:=1 to RowCount-1 do
      if AnsiLowerCase(ANInt)=AnsiLowerCase(Cells[1, i]) then
      begin //      ,   
        Row := i;
        Col := 1;
        //edtFindInLst.SetFocus;
        Exit;
      end;
    Row := RowCount - 1; //    
  end;
  //edtFindInLst.SetFocus;
end;

procedure TfrmEditLst.tlbtnOpenLstClick(Sender: TObject);
begin //  lst-
  grdLst.EditorMode := False;
  if not(ChangeInLst(Sender)) then Exit;
  opndlgOpenLst.InitialDir := ExtractFilePath(LstName);
  if opndlgOpenLst.Execute then
  begin
    GridDlgMSGInitial; //   lst-  
    LstName := opndlgOpenLst.FileName;
    try
      LoadLst(LstName); //  lst-
      //SetFocusTekMemo(Sender); //   
      //opndlgOpenLst.InitialDir := ExtractFilePath(LstName);
      SaveLstPathToINI(LstName);
    except
      ShowMessage(' : Lst-   .');
      //AFileName := CNameDefault; //    noname
    end;
  end;
end;

procedure TfrmEditLst.FormActivate(Sender: TObject);
begin
  //frmLstEditor.SetFocus;
  LstName := LoadLstPathFromINI;
  if LstName='' then tlbtnOpenLstClick(Sender)
  else if FileExists(LstName) then LoadLst(LstName);
  edtFindInLst.Text := PrgOpt.LstFindString;
end;

procedure TfrmEditLst.tlbtnSaveLstClick(Sender: TObject);
begin //  lst-
  grdLst.EditorMode := False;
  SavedLst(LstName);
end;

function TfrmEditLst.SavedLst(const AName: string): Boolean;
var
  nl: Longint; //   
  AStr, TmpName: string;
  ATmp: TMemoryStream;
begin //     
  Result := False;
  ATmp := TMemoryStream.Create;
  try
    with grdLst, rcdtTempLst do
      for nl:=1 to RowCount-1 do
      begin
        Application.ProcessMessages();
        if CheckClearString(nl) then Continue; //    
        TmpName := Cells[1, nl];
        if (TmpName='') or (Cells[3, nl]='') or
           (AnsiLowerCase(Copy(TmpName, Length(TmpName)-3 ,4))<>'.int') or
            (Length(TmpName)>12) then
        begin //   
          Row := nl;
          Col := 1;
          //grdLst.Visible := True;
          //frmEditLst.Enabled := True;
          //GridDlgMSGInitial;
          if TmpName='' then
          begin
            MessageBox(GetForegroundWindow, //     GetForegroundWindow
              PChar('     , '+//CR+
                    '      '+ IntToStr(nl)+'.'+CR+CR+
                    'ERROR:    .'),
              PChar('  '), MB_ICONERROR + MB_OK);
            Exit;
          end;
          if Cells[3, nl]='' then
          begin
            MessageBox(GetForegroundWindow, //     GetForegroundWindow
              PChar('     , '+//CR+
                    '      '+ IntToStr(nl)+'.'+CR+CR+
                    'ERROR:    LVar.'),
              PChar('  '), MB_ICONERROR + MB_OK);
            Exit;
          end;
          if AnsiLowerCase(Copy(TmpName, Length(TmpName)-3 ,4))<>'.int' then
          begin
            MessageBox(GetForegroundWindow, //     GetForegroundWindow
              PChar('     , '+//CR+
                    '      '+ IntToStr(nl)+'.'+CR+CR+
                    'ERROR:      (  ".int").'),
              PChar('  '), MB_ICONERROR + MB_OK);
            Exit;
          end;
          //(Length(TmpName)>12) and
          if MessageBox(GetForegroundWindow, //     GetForegroundWindow
              PChar('  '+//CR+
                    '    '+ IntToStr(nl)+'.'+CR+CR+
                    'ERROR:   ( )     8 .'+CR+CR+
                    '  ?'),
              PChar('  '), MB_ICONWARNING + MB_YESNO)<>IDYES then
              Exit;

          (*
            MessageBox(GetForegroundWindow, //     GetForegroundWindow
              PChar('     , '+//CR+
                    '      '+ IntToStr(nl)+'.'+CR+CR+
                    'ERROR:   ( )     8 .'),
              PChar('  '), MB_ICONERROR + MB_OK);
          *)
          {
          MessageBox(GetForegroundWindow, //     GetForegroundWindow
            PChar('     ,'+CR+
                  '      '+ IntToStr(nl)+'.'),
            PChar('  '), MB_ICONERROR + MB_OK);
          }
          //Row := nl;
          //Col := 1;
          //Exit;
        end;
        AStr := Cells[1, nl] + AddSpacesInStr(Cells[1, nl], 16) + '; ' +
                Cells[2, nl] + AddSpacesInStr(Cells[2, nl], 46) + '# local_vars=' +
                Cells[3, nl];

        if (nl<RowCount-2) or not(CheckClearString(nl+1)) then AStr:=AStr+CR;
        ATmp.WriteBuffer(pointer(AStr)^, Length(AStr));
      end;
    ATmp.SaveToFile(AName);
    tlbtnSaveLst.Enabled := False; //    
    Result := True;
  finally
    ATmp.Free;
  end;
end;

procedure TfrmEditLst.grdLstKeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then Exit;//  Enter
  with grdLst do
  begin
    //    
    if (Col=1) and not(Key in ['0'..'9', 'a'..'z', 'A'..'Z', '.', '_', #8]) then Key := #0;
    //if (Col=1) and not(Key in [#8]) and (Length(Cells[1, Row])>11) then Key := #0;
    //   
    if (Col=2) and not(Key in [#8]) and (Length(Cells[2, Row])>44) then Key := #0;
    //   LVARs
    if (Col=3) and not(Key in ['0'..'9', #8]) then Key := #0;
    if (Col=3) and not(Key in [#8]) and (Length(Cells[3, Row])>2) then Key := #0;
  end;
end;

procedure TfrmEditLst.tlbtnRegScriptClick(Sender: TObject);
var
  AName: string;
  i: Integer;
begin //    lst-
  with grdLst do
  begin
    AName := ChangeFileExt(ExtractFileName(AFileName), '.int');
    for i:=1 to RowCount-1 do
      if AnsiLowerCase(AName)=AnsiLowerCase(Cells[1, i]) then {!!!}
      begin
        SetFocus;
        Row := i;
        Col := 1;
        //ShowMessage(' ');
        edtFindInLst.SetFocus;
        Exit;
      end;
    if Length(AName)>12 then {!!!}
    begin
      //ShowMessage('Script name too big, no registred');
      MessageBox(GetForegroundWindow, //     GetForegroundWindow
                 PChar('   .'),
                 PChar(' '), MB_ICONERROR + MB_OK);
      edtFindInLst.SetFocus;
      Exit;
    end;
    if not(CheckClearString(RowCount-1)) then RowCount := RowCount + 1;
    Cells[0, RowCount-1] := IntToStr(RowCount-1);
    Cells[1, RowCount-1] := AName;
    SetFocus;
    Row := RowCount - 1;
    //Col := 2;
    RowCount := RowCount + 1;
    Cells[0, RowCount-1] := IntToStr(RowCount-1);
    tlbtnSaveLst.Enabled := True;
    Col := 2;
    grdLst.SetFocus;
    grdLst.EditorMode := True;
    Exit;
  end;
  edtFindInLst.SetFocus;
end;

function TfrmEditLst.CheckClearString(ANum: Word):Boolean;
begin //    ,  True
  Result := False;
  with grdLst do
    if (Cells[1, ANum]='') and (Cells[2, ANum]='') and
       (Cells[3, ANum]='') then Result := True;
end;

procedure TfrmEditLst.tlbtnDelStrClick(Sender: TObject);
var i: Word;
begin //    
  tlbtnSaveLst.Enabled := True;
  with grdLst do
  begin
    for i:=Row+1 to RowCount do Rows[i-1] := Rows[i];
    if RowCount>2 then RowCount := RowCount - 1;
    if not(CheckClearString(RowCount-1)) then
    begin //     ,    
      RowCount := RowCount + 1;
      Row := RowCount - 1;
    end;
    for i:=1 to RowCount-1 do Cells[0, i] := IntToStr(i);
  end;
end;

procedure TfrmEditLst.grdLstGetEditText(Sender: TObject; ACol,
  ARow: Integer; var Value: String);
begin //     
  AStrEsc := Value;
end;

procedure TfrmEditLst.grdLstSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
begin //    
  if AStrEsc<>Value then tlbtnSaveLst.Enabled := True;
  //else tlbtnSaveLst.Enabled := False;
end;

procedure TfrmEditLst.tlbtnAddStrClick(Sender: TObject);
var i: Word;
begin //   ,  
  tlbtnSaveLst.Enabled := True;
  with grdLst do
  begin
    RowCount := RowCount + 1;
    for i:=RowCount-1 downto Row+1 do Rows[i] := Rows[i-1];
    Rows[Row+1].Clear;
    for i:=1 to RowCount-1 do Cells[0, i] := IntToStr(i);
    Row := Row + 1;
    Col := 1;
  end;
end;

function TfrmEditLst.ChangeInLst(Sender: TObject): Boolean;
var APress: Word;
begin //  -   
  Result := True;
  if tlbtnSaveLst.Enabled then
  begin
    //Result := False;
    APress := MessageBox(GetForegroundWindow, //     GetForegroundWindow
      PChar(' "' + ExtractFileName(LstName) + '"  .  ?'),
      PChar('  '), MB_ICONWARNING + MB_YESNOCANCEL);
      case APress of
        6:        Result := SavedLst(LstName);
        7:        Result := True; //   
        2:        Result := False; //  
      else        ShowMessage(' :     -     !!!');
    end;
  end;
end;

procedure TfrmEditLst.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin //    ,   
  //PrgOpt.LstFindString := edtFindInLst.Text;
  CanClose := ChangeInLst(Sender); //     ""
end;

procedure TfrmEditLst.grdLstKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  //CtrlPress := (ssCtrl in Shift);
  with grdLst do
  begin
    if (key=VK_ESCAPE) and (EditorMode) and (AStrEsc<>'') then //  Esc
    begin
      EditorMode := False;
      Cells[Col, Row] := AStrEsc;
      //tlbtnSaveLst.Enabled := False;
    end;
  end;
end;

procedure TfrmEditLst.grdLstDblClick(Sender: TObject);
var
  ACol, ARow: Integer;
  ScrName: string;
begin
  with grdLst do
  begin
    //MouseCoord(xc, yc);
    MouseToCell(xc, yc, ACol, ARow);
    //stsbrLstEditor.Panels[0].Text := IntToStr(ACol)+' ' + IntToStr(ARow);
    if (ACol=-1) or (ARow=-1) then Exit; //    
    if (ACol=0) then //     
    begin
      EditorMode := False;
      ScrName := Cells[1, ARow]; //   
      if ScrName='' then Exit; //    
      //stsbrLstEditor.Panels[0].Text := ScrName;
      //stsbrDlgEditor.Panels[0].Text := IntToStr(ACol)+' ' + IntToStr(ARow);
      with frmMain do
      begin
        //stsbrLstEditor.Panels[0].Text := ScrName;
        ScrName := FindScriptInPath(ScrName);
        //stsbrLstEditor.Panels[0].Text := ScrName;
        if ScrName<>'' then
        begin
          //LoadInCmdLine(ScrName); //   
          //PrepareAndLoadScript(ScrName, False);
          //***
          if ChangeCheck(Sender) then
          try
            //PrepareAndLoadScript(ScrName, False); //   ,     
            LoadInCmdLine(ScrName);
          except
            ShowMessage(' :       "grdLstDblClick"');
            AFileName := CNameDefault; //    noname
          end;
          //***
          if tlbtnSaveLst.Enabled then ModalResult := mrCancel;
        end;
      end;
    end;
  end;
end;

procedure TfrmEditLst.grdLstMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin //   
  xc := X;
  yc := Y;
end;

function TfrmEditLst.FindInLst(const AStr: string; ToDown: Boolean): Boolean;
var cl, rw: Integer;
begin //      ,  True,   AStr 
      // ToDown=True   
  Result := False;
  //if AStr='' then Exit;
  with grdLst do
  begin
    cl := 0;
    rw := 1;
    if ToDown then //   
    begin
      rw := Row;
      cl := Col + 1;
      if cl>3 then
      begin
        cl := 0;
        rw := rw + 1;
      end;
    end;
    if not(ToDown) then //   
    begin
      rw := Row;
      cl := Col - 1;
      if cl<0 then
      begin
        cl := 3;
        rw := rw - 1;
      end;
    end;
    while (rw<RowCount) and (rw>0) do
    begin
      while (cl<=3) and (cl>=0) do
      begin
        if Pos(AnsiLowerCase(AStr), AnsiLowerCase(Cells[cl, rw]))<>0 then
        begin
          //SetFocus;
          edtFindInLst.SetFocus;
          Row := rw;
          Col := cl;
          Result := True;
          Exit;
        end;
        //stsbrLstEditor.Panels[0].Text := AnsiLowerCase(Cells[cl, rw]);
        //ShowMessage('Stop');
        if ToDown then cl := cl + 1 //   
        else cl := cl - 1; //   
      end;
      if ToDown then //   
      begin
        rw := rw + 1;
        cl := 0;
      end
      else //   
      begin
        rw := rw - 1;
        cl := 3;
      end;
    end;
  end;
end;

procedure TfrmEditLst.tlbtnGoBeginClick(Sender: TObject);
begin //   
  grdLst.Col := 1;
  grdLst.Row := 1;
  edtFindInLst.SetFocus;
end;

procedure TfrmEditLst.tlbtnGoEndClick(Sender: TObject);
begin //   
  grdLst.Col := 1;
  grdLst.Row := grdLst.RowCount - 1;
  edtFindInLst.SetFocus;
end;

procedure TfrmEditLst.tlbtnFindDownClick(Sender: TObject);
begin //     
  grdLst.EditorMode := False;
  if edtFindInLst.Text='' then Exit;
  if not(FindInLst(edtFindInLst.Text, True)) then
    if MessageBox(Self.Handle,
         PChar(' .    ?'),
         PChar(' '), MB_ICONWARNING + MB_YESNO) = 6 then
      tlbtnGoBeginClick(Sender);
end;

procedure TfrmEditLst.tlbtnFindUpClick(Sender: TObject);
begin //     
  grdLst.EditorMode := False;
  if edtFindInLst.Text='' then Exit;
  if not(FindInLst(edtFindInLst.Text, False)) then
    if MessageBox(Self.Handle,
         PChar(' .    ?'),
         PChar(' '), MB_ICONWARNING + MB_YESNO) = 6 then
      tlbtnGoEndClick(Sender);
end;

procedure TfrmEditLst.edtFindInLstKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key=VK_RETURN then // Enter
  begin //       
    tlbtnGoBeginClick(Sender);
    tlbtnFindDownClick(Sender);
  end;
end;

procedure TfrmEditLst.edtFindInLstChange(Sender: TObject);
begin
  PrgOpt.LstFindString := edtFindInLst.Text;
end;

end.
